include "Zeropage.inc"
include "Vram.inc"

pSource equ ZW0
pDestination equ ZW1
charByte equ ZB0


; void InitVdc();
cseg
InitVdc_: public InitVdc_
    defb $03,5 ; st0
    defb $13,$c8 ; st1
    defb $23,0 ; st2

    defb $03,9 ; st0
    defb $13,$00 ; st1
    defb $23,0 ; st2

    defb $03,7 ; st0
    defb $13,0 ; st1
    defb $23,0 ; st2

    defb $03,8 ; st0
    defb $13,248 ; st1
    defb $23,0 ; st2
rts


; void InitColors();
cseg
ColorValues:
	defb	$00, $00, $56, $00, $38, $00, $36, $01
	defb	$c0, $01, $c7, $01, $f8, $01, $ff, $01
	defb	$00, $00, $db, $00, $30, $01, $aa, $00
	defb	$c0, $00, $84, $00, $b9, $01, $6d, $01
InitColors_: public InitColors_
    pha
        ldx #0
        ldy #0
        do
            sty $0403
            defb $5a ; phy
                ldy #0
                do
                    sty $0402
                    lda ColorValues,x | inx
                    sta $0404
                    lda ColorValues,x | inx
                    sta $0405
                    iny
                while ne | wend
            defb $7a ; ply
            iny
            cpy #2
        while ne | wend
    pla
rts


cseg
MakeDestination:
    sta <pDestination | lda #0 | sta <pDestination+1
    asl <pDestination | rol <pDestination+1 ;*2
    asl <pDestination | rol <pDestination+1 ;*4
    asl <pDestination | rol <pDestination+1 ;*8
    asl <pDestination | rol <pDestination+1 ;*16
    lda <pDestination | clc|adc #low CharPatternRam | sta <pDestination
    lda <pDestination+1 | adc #high CharPatternRam | sta <pDestination+1
    defb $03,$00 ; st0
    lda <pDestination | sta >$0002
    lda <pDestination+1 | sta >$0003
rts


; void InitMonoChar(byte c, ptr<byte> pSource, byte count, byte color);
dseg
InitMonoChar_@Param0: public InitMonoChar_@Param0
    defb 0 ; c
InitMonoChar_@Param1: public InitMonoChar_@Param1
    defw 0 ; pSource
InitMonoChar_@Param2: public InitMonoChar_@Param2
    defb 0 ; count
InitMonoChar_@Param3: public InitMonoChar_@Param3
    defb 0 ; color
cseg
InitMonoChar_: public InitMonoChar_
    pha
        sei
            lda InitMonoChar_@Param1 | sta <pSource
            lda InitMonoChar_@Param1+1 | sta <pSource+1

            lda InitMonoChar_@Param0
            jsr MakeDestination
            do
                ldy #0
                do
                    defb $03,$02 ; st0
                    lda InitMonoChar_@Param3
                    and #$01
                    if ne
                        lda (<pSource),y
                    else
                        lda #0
                    endif
                    sta <charByte
                    lda InitMonoChar_@Param3
                    and #$10
                    if ne
                        lda (<pSource),y
                    else
                        lda #0
                    endif
                    ora <charByte
                    sta >$0002
                    lda InitMonoChar_@Param3
                    and #$02
                    if ne
                        lda (<pSource),y
                    else
                        lda #0
                    endif
                    sta <charByte
                    lda InitMonoChar_@Param3
                    and #$20
                    if ne
                        lda (<pSource),y
                    else
                        lda #0
                    endif
                    ora <charByte
                    sta >$0003
                    iny
                    cpy #8
                while ne | wend
                ldy #0
                do
                    defb $03,$02 ; st0
                    lda InitMonoChar_@Param3
                    and #$04
                    if ne
                        lda (<pSource),y
                    else
                        lda #0
                    endif
                    sta <charByte
                    lda InitMonoChar_@Param3
                    and #$40
                    if ne
                        lda (<pSource),y
                    else
                        lda #0
                    endif
                    ora <charByte
                    sta >$0002
                    lda InitMonoChar_@Param3
                    and #$08
                    if ne
                        lda (<pSource),y
                    else
                        lda #0
                    endif
                    sta <charByte
                    lda InitMonoChar_@Param3
                    and #$80
                    if ne
                        lda (<pSource),y
                    else
                        lda #0
                    endif
                    ora <charByte
                    sta >$0003
                    iny
                    cpy #8
                while ne | wend
                lda <pSource | clc|adc #8 | sta <pSource
                lda <pSource+1 | adc #0 | sta <pSource+1
                dec InitMonoChar_@Param2
            while ne | wend
        cli
    pla
rts


; void InitColorChar(byte c, ptr<byte> pSource, byte count);
dseg
InitColorChar_@Param0: public InitColorChar_@Param0
    defb 0 ; c
InitColorChar_@Param1: public InitColorChar_@Param1
    defw 0 ; pSource
InitColorChar_@Param2: public InitColorChar_@Param2
    defb 0 ; count
cseg
InitColorChar_: public InitColorChar_
    pha
        sei
            lda InitColorChar_@Param1 | sta <pSource
            lda InitColorChar_@Param1+1 | sta <pSource+1

            lda InitColorChar_@Param0
            jsr MakeDestination
            do
                ldy #0
                do
                    defb $03,$02 ; st0
                    lda (<pSource),y | iny
                    sta >$0002
                    lda (<pSource),y | iny
                    sta >$0003
                    cpy #32
                while ne | wend
                lda <pSource | clc|adc #32 | sta <pSource
                lda <pSource+1 | adc #0 | sta <pSource+1
                dec InitColorChar_@Param2
            while ne | wend
        cli
    pla
rts


; void ClearScreen();
cseg
ClearScreen_: public ClearScreen_
    pha
        sei
            defb $03,$00 ; st0
            defb $13,$00 ; st1
            defb $23,$00 ; st2
            ldx #10
            do
                ldy #0
                do
                    defb $03,$02 ; st0
                    defb $13,$00 ; st1
                    defb $23,$01 ; st2
                    dey
                while ne | wend
                dex
            while ne | wend
        cli
    pla
rts


; ptr<byte> VramAddress(byte x, byte y)
dseg
VramAddress_@Param0: public	VramAddress_@Param0
    defs 1
VramAddress_@Param1: public	VramAddress_@Param1
    defs 1
cseg
VramAddress_: public VramAddress_
    pha
        lda	VramAddress_@Param1
        asl	a ; *2
        asl	a ; *4
        sta <pDestination
        lda #0 | sta <pDestination+1
        asl	<pDestination | rol <ZW0+1 ; *8
        asl	<pDestination | rol <pDestination+1 ; *16
        asl	<pDestination | rol <pDestination+1 ; *32

        lda <pDestination | clc|adc VramAddress_@Param0 | sta <pDestination
        lda <pDestination+1 | adc #0 | sta <pDestination+1

        lda <pDestination | clc|adc #low Vram | tay
        lda <pDestination+1 | adc #high Vram | tax
	pla
rts


; word Put(word vram, byte c);
dseg
Put_@Param0: public Put_@Param0
    defw 0
Put_@Param1: public Put_@Param1
    defb 0
cseg
Put_: public Put_
    pha
        sei
            defb $03,$00 ; st0
            lda Put_@Param0 | sta >$0002
            lda Put_@Param0+1 | sta >$0003
            defb $03,$02 ; st0
            lda Put_@Param1 | sta >$0002
            lda #$01 | sta >$0003
        cli
        lda Put_@Param0 | clc|adc #1 | tay
        lda Put_@Param0+1 | adc #0 | tax
    pla
rts
